'use strict';

// Load NPM modules

Object.defineProperty(exports, '__esModule', {
  value: true,
});
exports.default = checkDispatch;

var _md = require('md5');

var _md2 = _interopRequireDefault(_md);

var _circularJson = require('circular-json');

var _circularJson2 = _interopRequireDefault(_circularJson);

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : { default: obj };
}

// Export
function checkDispatch() {
  var fatal =
    arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

  // Track hash of last action
  var lastActionHash = '';
  // Declare functions
  var getHash = function getHash() {
    var action =
      arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
    return (0, _md2.default)(_circularJson2.default.stringify(action));
  };
  var checkHash = function checkHash() {
    var action =
      arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
    return !(getHash(action) === lastActionHash);
  };
  var updateHash = function updateHash() {
    var action =
      arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
    return (lastActionHash = getHash(action));
  };
  // Middleware
  return function(store) {
    return function(next) {
      return function(action) {
        if (checkHash(action)) {
          return updateHash(action) && next(action);
        } else {
          // Define message
          var message =
            '[redux-duplicate-actions] A duplicate action has been detected. MORE INFO: ' +
            _circularJson2.default.stringify(action, null, 2);
          // Handle fatal or not?
          if (fatal) {
            throw new TypeError(message);
          } else {
            return console.warn(message) || next(action);
          }
        }
      };
    };
  };
}
